# ReadSessions

The ReadSession API allows for consumers to stream large amounts of data to other environments in a performant, resumable, and parallelized manner. The general flow is to create a ReadSession on a specific table, upload, or query result, and then read from the stream(s) within that ReadSession.

{% hint style="info" %}
ReadSessions are somewhat complicated and rely on extra orchestration to manage state and handle retries. When using the R, Python, or Javascript client libraries, such nuances are automatically handled.&#x20;

When using the REST API with smaller tables, consider calling the `listRows` method on the relevant resources. E.g.: `/tables/<table>/rows?format=csv`.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.redivis.com/api/rest-api/readsessions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
